package classicguns;


import net.minecraft.sounds.SoundEvent;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegisterEvent;
import net.minecraftforge.registries.RegistryObject;

/**
 * Registers this mod's {@link SoundEvent}s.
 *
 * @author Choonster
 */
public class CGSoundEvent {

    public static final DeferredRegister<SoundEvent> SOUND_EVENTS =
            DeferredRegister.create(ForgeRegistries.SOUND_EVENTS, mod_ClassicGuns.MOD_ID);

    public static RegistryObject<SoundEvent> fire_rifle = registerSound("fire_rifle");
    public static RegistryObject<SoundEvent> fire_hg = registerSound("fire_hg");
    public static RegistryObject<SoundEvent> fire_smg = registerSound("fire_smg");
    public static RegistryObject<SoundEvent> fire_grenade = registerSound("fire_grenade");
    public static RegistryObject<SoundEvent> reload_mag = registerSound("reload_mag");
    public static RegistryObject<SoundEvent> throw_grenade = registerSound("throw_grenade");

    public static void register(IEventBus eventBus) {
        SOUND_EVENTS.register(eventBus);
    }



    /**
     * Register the {@link SoundEvent}s.
     */
    public static void registerSounds(RegisterEvent event) {
        /*reload_mag = registerSound("classicguns.reload_mag", reload_mag);
        fire_rifle = registerSound("classicguns.fire_rifle", reload_mag);
        fire_hg = registerSound("classicguns.fire_hg", reload_mag);
        fire_smg = registerSound("classicguns.fire_smg", reload_mag);
        fire_grenade = registerSound("classicguns.fire_grenade", reload_mag);
        throw_grenade = registerSound("classicguns.throw_grenade", reload_mag);*/
        /*fire_hg = RegistryObject.create(new ResourceLocation(mod_ClassicGuns.MOD_ID,"fire_hg"), ForgeRegistries.SOUND_EVENTS);
        event.register(ForgeRegistries.Keys.SOUND_EVENTS,
                helper -> {
                            helper.register(new ResourceLocation(mod_ClassicGuns.MOD_ID,"fire_hg"),
                                    new SoundEvent(new ResourceLocation(mod_ClassicGuns.MOD_ID,"fire_hg")));
                }
        );*/

    }


    public static SoundEvent getSound(String soundbase) {
        SoundEvent sound = fire_hg.get();
        if(soundbase.equals("reload_mag")) {
            sound = reload_mag.get();
        }
        if(soundbase.equals("fire_rifle")) {
            sound = fire_rifle.get();
        }
        if(soundbase.equals("fire_hg")) {
            sound = fire_hg.get();
        }
        if(soundbase.equals("fire_smg")) {
            sound = fire_smg.get();
        }
        if(soundbase.equals("fire_grenade")) {
            sound = fire_grenade.get();
        }
        if(soundbase.equals("throw_grenade")) {
            sound = throw_grenade.get();
        }
        return sound;
    }


    private static RegistryObject<SoundEvent> registerSound(String soundName) {
        return SOUND_EVENTS.register(soundName, () -> new SoundEvent(new ResourceLocation(mod_ClassicGuns.MOD_ID, soundName)));
    }

    /**
     * Register a {@link SoundEvent}.
     *
     * @param soundName The SoundEvent's name without the testmod3 prefix
     * @return The SoundEvent
     */
    /*private static SoundEvent registerSound(String soundName, SoundEvent event) {
        ResourceLocation soundID = new ResourceLocation(mod_ClassicGuns.MOD_ID, soundName);
        //return new SoundEvent(soundID).setRegistryName(soundID);
        ForgeRegistries.SOUND_EVENTS.register(new ResourceLocation(mod_ClassicGuns.MOD_ID, soundName), event);
        return event;
    }*/


}