package classicguns;


import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.BowItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;

public class ItemGrenade extends BowItem {
    public ItemGrenade(Item.Properties builder) {
        super(builder);
    }

    public void releaseUsing(ItemStack stack, Level worldIn, LivingEntity entityLiving, int timeLeft) {
        if (entityLiving instanceof Player) {
            Player playerIn = (Player)entityLiving;
            //worldIn.playSound((PlayerEntity)null, playerIn.getPosX(), playerIn.getPosY(), playerIn.getPosZ(), SoundEvents.ENTITY_SNOWBALL_THROW, SoundCategory.NEUTRAL, 0.5F, 0.4F / (random.nextFloat() * 0.4F + 0.8F));
            worldIn.playSound((Player)null, playerIn.getX(), playerIn.getY(), playerIn.getZ(),
                    SoundEvents.SNOWBALL_THROW, SoundSource.NEUTRAL,
                    0.5F, 0.4F / (worldIn.getRandom().nextFloat() * 0.4F + 0.8F));
            if (!worldIn.isClientSide) {
                EntityGrenade snowballentity = new EntityGrenade(worldIn, playerIn);
                snowballentity.setItem(stack);
                snowballentity.shootFromRotation(playerIn, playerIn.getXRot(), playerIn.getYRot(), 0.0F, 1.5F, 1.0F);
                worldIn.addFreshEntity(snowballentity);
            }

            if (!playerIn.getAbilities().instabuild) {
                stack.shrink(1);
            }
        }
    }

    public InteractionResultHolder<ItemStack> use(Level worldIn, Player playerIn, InteractionHand p_40674_) {

        ItemStack itemstack = playerIn.getItemInHand(p_40674_);
        playerIn.startUsingItem(p_40674_);
        return InteractionResultHolder.sidedSuccess(itemstack, worldIn.isClientSide());
    }
}
