package classicguns;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.client.event.EntityRenderersEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.loading.FMLLoader;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.RegisterEvent;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@Mod(mod_ClassicGuns.MOD_ID)
public class mod_ClassicGuns {
    public static mod_ClassicGuns INSTANCE;
    public static final String MOD_ID = "classicguns";

    private static final Logger LOGGER = LogManager.getLogger();

    public static RegistryObject<Item> item_bullet;
    public static  RegistryObject<Item> item_hg;
    public static  RegistryObject<Item> item_smg;
    public static  RegistryObject<Item> item_sr;
    public static  RegistryObject<Item> item_sg;
    public static  RegistryObject<Item> item_mg;
    public static  RegistryObject<Item> item_grenade;
    public static  RegistryObject<Item> item_gl;
    public static  RegistryObject<Item> item_flare;

    public static RegistryObject<EntityType<EntityBullet>> ENTITY_BULLET;
    public static RegistryObject<EntityType<EntityGrenade>> ENTITY_GRENADE;

    public mod_ClassicGuns() {
        IEventBus eventBus = FMLJavaModLoadingContext.get().getModEventBus();

        //AddItems.register(eventBus);

        CGSoundEvent.register(eventBus);
        eventBus.addListener(this::setup);

        // Register ourselves for server and other game events we are interested in
        MinecraftForge.EVENT_BUS.register(this);

        if (FMLLoader.getDist().isClient()) {
            MinecraftForge.EVENT_BUS.register(new RenderGunEvent());
            MinecraftForge.EVENT_BUS.register(new RenderGunZoom());
        }
    }

    private void initClient(FMLClientSetupEvent event) {
       // RenderingRegistry.registerEntityRenderingHandler(ENTITY_BULLET, RenderBullet::new);
       // RenderingRegistry.registerEntityRenderingHandler(ENTITY_GRENADE, RenderGrenade::new);
    }

    // add a comment
    private void setup(final FMLCommonSetupEvent event) {
        // some preinit code
        LOGGER.info("HELLO FROM PREINIT");
        //LOGGER.info("DIRT BLOCK >> {}", Blocks.DIRT.getRegistryName());
        LOGGER.info("DIRT BLOCK >> {}", ForgeRegistries.BLOCKS.getKey(Blocks.DIRT));
    }

    @Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
    public static class RegistryEvents {

        @SubscribeEvent
        public static void registerSoundEvents(RegisterEvent event) {
            //CGSoundEvent.registerSounds(event);
        }

        @SubscribeEvent
        public static void onItemsRegistry(RegisterEvent event) {
            AddItems.registerItem(event);
            AddGuns.registerItem(event);
        }

        @SubscribeEvent
        public static void registerEntityTypes(RegisterEvent event) {
            ENTITY_BULLET = RegistryObject.create(new ResourceLocation(MOD_ID,"entitybullet"), ForgeRegistries.ENTITY_TYPES);
            ENTITY_GRENADE = RegistryObject.create(new ResourceLocation(MOD_ID,"entitygrenade"), ForgeRegistries.ENTITY_TYPES);
            event.register(ForgeRegistries.Keys.ENTITY_TYPES,
                    helper -> {
                        helper.register(
                                new ResourceLocation("classicguns", "entitybullet"),
                                EntityType.Builder.<EntityBullet>of(EntityBullet::new, MobCategory.MISC)
                                        .setCustomClientFactory(EntityBullet::new)
                                        .sized(0.15F, 0.15F)
                                        .setShouldReceiveVelocityUpdates(false)
                                        .setTrackingRange(60)
                                        .setUpdateInterval(60)
                                        .build("classicguns:entitybullet"));

                        helper.register(
                                new ResourceLocation("classicguns", "entitygrenade"),
                                EntityType.Builder.<EntityGrenade>of(EntityGrenade::new,MobCategory.MISC)
                                        .setCustomClientFactory(EntityGrenade::new)
                                        .sized(0.15F, 0.15F)
                                        .setShouldReceiveVelocityUpdates(false)
                                        .setTrackingRange(61)
                                        .setUpdateInterval(61)
                                        .build("classicguns:entitygrenade"));
                    }
            );

            /*ENTITY_GRENADE = EntityType.Builder.<EntityGrenade>of(EntityGrenade::new,MobCategory.MISC)
                    .setCustomClientFactory(EntityGrenade::new)
                    .sized(0.15F, 0.15F)
                    .setShouldReceiveVelocityUpdates(false)
                    .setTrackingRange(61)
                    .setUpdateInterval(61)
                    .build("classicguns:entitygrenade");
            ForgeRegistries.ENTITIES.register(new ResourceLocation("classicguns", "entitygrenade"), ENTITY_GRENADE);
            //ENTITY_GRENADE.setRegistryName(new ResourceLocation("classicguns", "entitygrenade"));
            // event.getRegistry().register(ENTITY_GRENADE);

            //event.getRegistry().registerAll(ENTITY_BULLET, ENTITY_GRENADE);//event.getRegistry().registerAll(ENTITY_BULLET, ENTITY_GRENADE);
*/

        }


    }

    @Mod.EventBusSubscriber(modid=mod_ClassicGuns.MOD_ID, value= Dist.CLIENT, bus=Mod.EventBusSubscriber.Bus.MOD)
    public static class ClientEvents {
        @SubscribeEvent
        public static void onRegisterRenderer(final EntityRenderersEvent.RegisterRenderers event) {
            event.registerEntityRenderer(ENTITY_BULLET.get(), RenderBullet::new);
            event.registerEntityRenderer(ENTITY_GRENADE.get(), RenderGrenade::new);
        }
    }
}